#ifndef GOAP_STATE_HPP
#define GOAP_STATE_HPP

#include "godot_cpp/classes/navigation_agent3d.hpp"
#include <godot_cpp/classes/node.hpp>
#include <godot_cpp/classes/node3d.hpp>

namespace gd = godot;

namespace goap {
class State : public gd::Node {
    GDCLASS(State, gd::Node);
    static void _bind_methods();
};

/*! Uses navigation to chase the desired target node.
 */
class MoveTo : public State {
    GDCLASS(MoveTo, State);
    static void _bind_methods();
public:
    virtual void _enter_tree() override;
    virtual void _exit_tree() override;
    virtual void _process(double delta_time) override;
public:
    gd::Node3D *target_node{nullptr};
private:
    gd::Node3D *parent_node3d{nullptr};
    gd::NavigationAgent3D *agent{nullptr};
};

class Activate : public State {
    GDCLASS(Activate, State);
    static void _bind_methods();
public:
    gd::Node3D *target_node{nullptr};
    gd::String animation{};
};

class Animate : public State {
    GDCLASS(Animate, State);
    static void _bind_methods();
public:
    gd::String animation{};
};
}

#endif // !GOAP_STATE_HPP
